# Palomino Flight Simulator - Manual

http://www.palomino3d.org

## Contents

- Keyboard
- Command-line Args
- Configuration Files
- Running

- Satellite Imagery
- Space/Time Compression

- Joystick
- Known Bugs

## Keyboard

CTRL+c | exit program
TAB, `(back-tick) | TAB: cycle view mode, `(back-tick) switch control to chase-view to next view
cursor left | right | roll
cursor up | down | pitch
key-pad: Ins | Del | yaw
key-pad: arrows | OTW view: change direction, chase-view: rotate
key-pad: - + 5/center | chase-view: zoom-in, zoom-out, reset
- = 0..9 | throttle
BACKSPACE | DELETE | reset program
g | landing gear
b | brakes
SPACE | fire weapon
t | switch targets
'[' ']' or joystick buttons 4,5 | adjust wing-sweep (F-14 Tomcat)
r,R | 'r' plays a replay. 'R' starts recording a new replay, then 'R' again stops recording and saves to file.
F1 | start GUI
F2 | save viewpoint (trackball mode)
F8 | cycle brightness
F9 | toggle automatic coordinated-turn (propeller aircraft)
F10, Shift+F10 | F10 : toggle stalling, Shift+F10 : toggle step mode (uses keypad to step)
F11 | reload scene.lua
F12 | display OSG statistics, Shift+F12 to dump scene graph to file
SPACE | restore viewpoint (trackball mode)

## Command-line Args

Args override preceding args and any counterparts in the configuration file.

-wh width height | Set window width,height.
-spitfire -corsair -p51 -f86 -f14 -f15 -f16 -f18 -sr71 -mirage -su37 | Select aircraft model.
-coturn -no-coturn | Whether program should automatically coordinate a turn for player.
-takeoff -front-slot -rear-slot | Begin at takeoff, specify which slot on aircraft carrier.
-no-physics -no-stall | Disable physics, disable aircraft stalling.
-hour | Set time-of-day.
-no-light | Disable lighting.
-fog -no-fog | Enable/disable fog.
-no-clouds | Disable clouds.
-no-sound or -ns | Disable audio.
-fast | Gains speed but loses rendering quality and capabilities.
-wire | Render in wireframe mode.
-motion-blur or -no-motion-blur | Doesn't work on all video cards.
-no-osg-opt | Disable OSG optimizer.
-no-stats | Disable OSG statistics.
-wimp or -cheat | Disable enemies (game mode).
-ossim | Enable fetching and rendering satellite imagery using OSSIM.
OSSIM: -low or -high | Start at low or high altitude.
OSSIM: -comp n | Set compression of simulated space/time.
-t | Enable OSG trackball mode (for debug or scene construction).
-step | Fully enable step mode (allows manual movement of viewpoint).

## Configuration Files

### data/palomino.conf

User-editable configuration file (subject-to-change in future versions).

### data/world.kwl

User-editable configuration of how satellite imagery is fetched. Static data and WMS servers can be specified.

### ~/.palomino

Not user-editable.
This subdirectory of the user's home directory contains binary data files (configuration, replay, etc).

## Running

### Satellite Imagery

To change which imagery OSSIM will fetch, edit data/world.kwl.
For example:

    archive0.type: local
    archive0.file0: /usr/local/ossim/earth/land_shallow_topo_east_tiled.tif
    archive0.file1: /usr/local/ossim/earth/land_shallow_topo_west_tiled.tif

Use the GUI to start the simulation at various places on the Earth.
lat : -90..+90 degrees (North Pole is +90, Equator is 0, South Pole is -90)
lon : 0..360 degrees
alt : meters

### Space/Time Compression

Applies to OSSIM.

The simulation can compress space/time. For example, changing compression scale (-comp) to 10 reduces the planet's scale by 10 so the simulation seems to run 10x faster.

To fly around the Earth very fast:
palomino -ossim -sr71 -high -comp 100

## Joystick

Program can use 4 joystick axises: roll, pitch, yaw, throttle.

Joystick and aircraft maneuverability have separate configurations. Rate-of-roll/pitch/yaw is defined by data/physics_*.conf in degrees/second.

### Enabling Joystick

Pass -j to enable joystick.
On Linux (and FreeBSD with the port devel/linux-js), either the Linux or GLUT joystick driver can be selected by -jlinux or -jglut.

### Calibrating Joystick

Pass -jp to print joystick values in order to calibrate joystick. Then edit data/joystick.conf.
Pass -jc [filename] to specify pathname to your custom joystick configuration file ("joystick.conf").

### Joystick Problems:

- Delayed reaction to joystick input:
  Try adjusting JoystickInputQueueOverflow or JoystickTickFreq in .conf.
- Linux: Try `modprobe joydev` or running as root.
- FreeBSD: Try installing the port devel/linux-js.
  linux-js emulates a Linux joystick driver at /dev/input/js0

## Known Bugs and Issues

- If GUI doesn't show:

Then the GUI wasn't compiled. To compile it, FTLK is required. cmake should show:
`-- Found FLTK: /usr/lib/libfltk.so`

- Fails to load 3D models (OSG plugin error):

Ensure that LD_LIBRARY_PATH (DYLD_LIBRAY_PATH Apple Mac) points to OSG plugin libraries:
/usr/local/lib/osgPlugins-N.N.N

- If graphics window has artifacts or mis-renders:

Try disabling options in this order:

1. -no-motion-blur
2. -no-osg-opt

- In chase-view, aircraft will disappear at high-altitude from some angles.

Problem is caused by OSG attempting to fit the immensely huge planet and the tiny aircraft into the view frustum. Try:

- passing -high
- zoom-out by pressing '+' (keypad)
- increasing compression scale: pass -comp n

© 2004,2008 Jim Brooks http://www.palomino3d.org
Last modified: Thu Dec 25 09:13:56 EST 2008